<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 35.10 Load all users</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="text-center my-5">
            <h3>DANH SÁCH NGƯỜI DÙNG</h3>
        </div>
        <div class="row form-group jumbotron">
            <div class="col-sm-4" style="padding-left: 290px; padding-top: 5px;">
                <label>Name:</label>
            </div>
            <div class="col-sm-4">
                <input type="text" class="form-control" id="inp-name">
            </div>
            <div class="col-sm-4">
                <button id="btn-loc-user" class="btn btn-success">Lọc user</button>
            </div>
        </div>
        <div>
            <table id="table-users" class="table table-striped table-bordered table-hover">
                <thead class="table-primary" style="color:#fff">
                    <tr>
                        <th>STT</th>
                        <th>Name</th>
                        <th>Username</th>
                        <th>Email</th>
                        <th>Address</th>
                        <th>Zipcode</th>
                        <th>Phone</th>
                        <th>Company</th>
                        <th>Action</th>
                    </tr>
                </thead>

                <tbody>

                </tbody>
            </table>
        </div>
        
    </div>
</body>
<script>
    //REGION 1
    var gName = [];
    //REGION 2
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện nút btn lọc user
        $("#btn-loc-user").on("click", onBtnLocUserClick);
    })
    //REGION 3
    //hàm load trang
    function onPageLoading(){
        callApiGetUsers();
    }
    //hàm thục hiện sự kiện nút chi tiết được ấn
    function onBtnDetailClick(paramEvent){
        console.log("chi tiết được ấn");
        var vBtnDetail = paramEvent.currentTarget
        var vIdUser = $(vBtnDetail).data("id");
        console.log("Id user: " + vIdUser);
        //ấn nút thì chuyển sang trang user detail
        var vUrl = "userDetail.html"
        var vUrlOpenToPage = vUrl + "?id=" + vIdUser;
        window.location.href = vUrlOpenToPage;
    }
    //hàm xử lý sự kiện lọc user click
    function onBtnLocUserClick(){
        //b1 thu thập dữ liệu
        var vNameObj = {Name: ""}
        getDataNameObj(vNameObj);
        //b2 kiểm tra dữ liệu
        var vIsCheck = validateNameObj(vNameObj)
        if(vIsCheck){
            // Bước 3: Lọc và hiển thị danh sách users thỏa mãn
            var vArrFilterUser = findUserByFilter(vNameObj);
            console.log(vArrFilterUser);
            var vTable = $("#table-users") // truy xuất table qua id
            vTable.find("tr:gt(0)").html("");
            if(vArrFilterUser.length > 0){
            //hiện thông báo đã được tìm thấy
            alert("tìm thây " + vArrFilterUser.length + " kết quả phù hợp");
            //hiển thị danh sách tìm được ra table
            findDataTableUser(vArrFilterUser)
            }
            else{
            alert("Không tìm thấy kết quả phù hợp");
            return false;
            }
            }
    }
    //REGION 4
    //hàm thục hiện lọc user
    function findUserByFilter(paramName){
        "use strict";
        const bArrResultObj = [];
        //kiểm tra name được nhập
        if(paramName.Name != ""){
            for(let bI = 0; bI <gName.length; bI++){
                const bItemUserObj = gName[bI]
                //thục hiện so sách từ khóa nhập vào với dữ liệu user
                if(paramName.Name.toLowerCase() === bItemUserObj.name.toLowerCase()){
                    bArrResultObj.push(bItemUserObj); 
                }
            }
        }
        return bArrResultObj;
    }
    //hàm hiển thị thông tin user đã được lọc lên table
    function findDataTableUser(paramUserObj){
        var vTable = $("#table-users");
        for(let bI = 0; bI < paramUserObj.length; bI++){
            console.log(gName);
            var bNewRow = $("<tr>").appendTo(vTable);
                $("<td>", {
                    html: paramUserObj[bI].id
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].name
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].username
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].email
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].address.street 
                    + ", " 
                    + paramUserObj[bI].address.suite
                    + ", " 
                    + paramUserObj[bI].address.city
                    + ", " 
                    + paramUserObj[bI].address.geo.lat
                    + ", " 
                    + paramUserObj[bI].address.geo.lng
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].address.zipcode
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].phone
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramUserObj[bI].company.name
                    + ", "
                    + paramUserObj[bI].company.catchPhrase
                    + ", "
                    + paramUserObj[bI].company.bs
                }).appendTo(bNewRow);

                //ở Action
                var bCellAction = $("<td>").appendTo(bNewRow);
                $("<button>", {
                    html: "chi tiết",
                    class: "btn btn-success"
                }).click(onBtnDetailClick)
                .data("id", paramUserObj[bI].id)
                .appendTo(bCellAction);
        }
    }
    //hàm thu thập dữ liệu name để loc user
    function getDataNameObj(paramName){
        paramName.Name = $("#inp-name").val().trim();
    }
    //hàm kiểm tra dữ liệu name obj
    function validateNameObj(paramNameObj){
        if(paramNameObj.Name == ""){
            alert("Bạn chưa nhập name");
            $("#inp-name").focus()
            return false;
        }
        return true;
    }
    //hàm gọi api để lấy danh sách user
    function callApiGetUsers(){
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/",
            type: "GET",
            dataType: "json",
            success: function(res){
                gName = res
                console.log(gName);
                //load data lên table
                loadDataToTable(res);
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        });
    }
    //hàm load dữ liệu lên table
    function loadDataToTable(paramResponse){
        var vTable = $("#table-users");
        for(let bI = 0; bI < paramResponse.length; bI++){
            console.log(gName);
            var bNewRow = $("<tr>").appendTo(vTable);
                $("<td>", {
                    html: paramResponse[bI].id
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].name
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].username
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].email
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].address.street 
                    + ", " 
                    + paramResponse[bI].address.suite
                    + ", " 
                    + paramResponse[bI].address.city
                    + ", " 
                    + paramResponse[bI].address.geo.lat
                    + ", " 
                    + paramResponse[bI].address.geo.lng
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].address.zipcode
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].phone
                }).appendTo(bNewRow);

                $("<td>", {
                    html: paramResponse[bI].company.name
                    + ", "
                    + paramResponse[bI].company.catchPhrase
                    + ", "
                    + paramResponse[bI].company.bs
                }).appendTo(bNewRow);

                //ở Action
                var bCellAction = $("<td>").appendTo(bNewRow);
                $("<button>", {
                    html: "chi tiết",
                    class: "btn btn-success"
                }).click(onBtnDetailClick)
                .data("id", paramResponse[bI].id)
                .appendTo(bCellAction);
        }
    }
</script>
</html>